const componentData = [
	{cid: Components.ID("{4df59042-5cd9-11dc-8314-0800200c9a66}"),
		contractid: "@mozilla.org/vcssupport/export;1?type=vcs",
		script: "vcsexport.js",
		constructor: "calVcsExporter",
		category: "cal-exporters",
		categoryEntry: "cal-vcs-exporter",
		service: false},
	{cid: Components.ID("{40a1b866-5e72-11dc-8314-0800200c9a66}"),
		contractid: "@mozilla.org/vcssupport/import;1?type=vcs",
		script: "vcsimport.js",
		constructor: "calVcsImporter",
		category: "cal-importers",
		categoryEntry: "cal-vcs-importer",
		service: false}
];

var vcsImportExportModule = {
	mScriptsLoaded: false,
	
	loadScripts: function () {
		if (this.mScriptsLoaded)
			return;

		const jssslContractID = "@mozilla.org/moz/jssubscript-loader;1";
		const jssslIID = Components.interfaces.mozIJSSubScriptLoader;

		const dirsvcContractID = "@mozilla.org/file/directory_service;1";
		const propsIID = Components.interfaces.nsIProperties;

		const iosvcContractID = "@mozilla.org/network/io-service;1";
		const iosvcIID = Components.interfaces.nsIIOService;

		var loader = Components.classes[jssslContractID].getService(jssslIID);
		var dirsvc = Components.classes[dirsvcContractID].getService(propsIID);
		var iosvc = Components.classes[iosvcContractID].getService(iosvcIID);

		// Note that unintuitively, __LOCATION__.parent == .
		var appdir = __LOCATION__.parent;

		for (var i = 0; i < componentData.length; i++) {
			var scriptName = componentData[i].script;
			if (!scriptName)
				continue;

			var f = appdir.clone();
			f.append(scriptName);

			try {
				var fileurl = iosvc.newFileURI(f);
				loader.loadSubScript(fileurl.spec, null);
			} catch (e) {
				dump("Error while loading " + fileurl.spec + "\n");
				throw e;
			}
		}

		this.mScriptsLoaded = true;
	},

	registerSelf: function (compMgr, fileSpec, location, type) {
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);

		var catman = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
		for (var i = 0; i < componentData.length; i++) {
			var comp = componentData[i];
			if (!comp.cid)
				continue;
				
			compMgr.registerFactoryLocation(comp.cid, "", comp.contractid, fileSpec, location, type);

			if (comp.category) {
				var contractid;
				if (comp.service)
					contractid = "service," + comp.contractid;
				else
					contractid = comp.contractid;
				catman.addCategoryEntry(comp.category, comp.categoryEntry, contractid, true, true);
			}
		}
	},

	makeFactoryFor: function(constructor) {
		var factory = {
			QueryInterface: function (aIID) {
				if (!aIID.equals(Components.interfaces.nsISupports) && !aIID.equals(Components.interfaces.nsIFactory))
					throw Components.results.NS_ERROR_NO_INTERFACE;
				return this;
			},

			createInstance: function (outer, iid) {
				if (outer != null)
					throw Components.results.NS_ERROR_NO_AGGREGATION;
				return (new constructor()).QueryInterface(iid);
			}
		};

		return factory;
	},

	getClassObject: function (compMgr, cid, iid) {
		if (!iid.equals(Components.interfaces.nsIFactory))
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

		if (!this.mScriptsLoaded)
			this.loadScripts();

		for (var i = 0; i < componentData.length; i++) {
			if (cid.equals(componentData[i].cid)) {
				if (componentData[i].onComponentLoad) {
					eval(componentData[i].onComponentLoad);
				}
				// eval to get usual scope-walking
				return this.makeFactoryFor(eval(componentData[i].constructor));
			}
		}

		throw Components.results.NS_ERROR_NO_INTERFACE;
	},

	canUnload: function(compMgr) {
		return true;
	}
};

function NSGetModule(compMgr, fileSpec) {
	return vcsImportExportModule;
}
